USE [COWS]
GO
/****** Object:  StoredProcedure [web].[retrieveCustomerByH1]    Script Date: 04/26/2011 16:25:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Ramesh Ragi>
-- Create date: <>
-- Description:	<Description,,>
-- =============================================
ALTER PROCEDURE [web].[retrieveCustomerByH1]
@APPLICATIONIDENTIFIER AS VARCHAR(3),
--@REQUESTORUSERIDENTIFIER AS VARCHAR(10) = '',
@USERIPADDRESS AS VARCHAR(11) = '',
@CIS_ID AS VARCHAR(50),
@CHARS_ID AS NUMERIC = 0
AS
BEGIN

BEGIN TRY
	CREATE TABLE #CUST_INFO_SENSITIVE_ALL
									(
										[CUST_CHARS_ID]			Int			NOT NULL,
										[SENS_DATA_TYPE_CD]		Varchar(4)	NOT NULL,
										[EFF_BEGIN_TMST]		DateTime	NOT NULL,
										[EFF_END_TMST]			DateTime	NOT NULL,
										[SCTY_GRP_CD]			Varchar(5)	NULL,
										[CNTRC_CD]				Varchar(3)	NOT NULL,
										[MSTR_CHARS_ID]			Int			NOT NULL,
										[SENS_NME]				Varchar(50) NULL,
										[TITLE_TXT]				Varchar(30) NULL,
										[LINE_1_ADR]			Varchar(26) NULL,
										[LINE_2_ADR]			Varchar(26) NULL,
										[CTY_NME]				Varchar(20) NULL,
										[STT_CD]				Varchar(2)	NULL,
										[PSTL_CD]				Varchar(15) NULL,
										[PROVINCE_CD]			Varchar(2)	NULL,
										[CTRY_CD]				Varchar(3)	NULL,
										[PHN_NBR]				Varchar(20) NULL,
										[PHN_EXT_NBR]			Varchar(4)	NULL,
										[EMAIL_ADR]				Varchar(60) NULL,
										[IPS_CYC_ID]			Varchar(2)	NULL,
										[IPS_RCVBL_TYPE_CD]		Varchar(1)	NULL,
										[SRVC_CD]				Varchar(3)	NULL,
										[RLAT_KEY_ID]			Varchar(50) NOT NULL,
										[ID_TYPE_CD]			Varchar(20) NOT NULL,
										[ID_TYPE_DES]			Varchar(50) NULL,
										[SCTY_GRP_DES]			Varchar(50) NULL,
										[SENS_DATA_TYPE_DES]	Varchar(30) NULL,
										[SENS_DATA_CAT_CD]		Varchar(4)	NULL,
										[SENS_DATA_CAT_DES]		Varchar(30)	NULL
									) 

		

	exec('CALL SENS_CTX.SET_CONTEXT_FGAC('''+@APPLICATIONIDENTIFIER+''', '''', '''')') AT L2PLink										
	
	DECLARE @CMD2 AS VARCHAR(MAX)

		SET @CMD2 = 'INSERT INTO #CUST_INFO_SENSITIVE_ALL ' +
		'([CUST_CHARS_ID],[SENS_DATA_TYPE_CD],[EFF_BEGIN_TMST],[EFF_END_TMST],[SCTY_GRP_CD],[CNTRC_CD] ' +
		',[MSTR_CHARS_ID],[SENS_NME],[TITLE_TXT],[LINE_1_ADR],[LINE_2_ADR],[CTY_NME],[STT_CD],[PSTL_CD] ' +
		',[PROVINCE_CD],[CTRY_CD],[PHN_NBR],[PHN_EXT_NBR],[EMAIL_ADR],[IPS_CYC_ID],[IPS_RCVBL_TYPE_CD] ' +
		',[SRVC_CD],[RLAT_KEY_ID],[ID_TYPE_CD],[ID_TYPE_DES],[SCTY_GRP_DES],[SENS_DATA_TYPE_DES] ' +
		',[SENS_DATA_CAT_CD],[SENS_DATA_CAT_DES]) ' +
		'SELECT CUST_CHARS_ID,SENS_DATA_TYPE_CD,EFF_BEGIN_TMST,EFF_END_TMST,SCTY_GRP_CD,CNTRC_CD ' +
		',MSTR_CHARS_ID,SENS_NME,TITLE_TXT,LINE_1_ADR,LINE_2_ADR,CTY_NME,STT_CD,PSTL_CD ' +
		',PROVINCE_CD,ISO_CTRY_CD,PHN_NBR,PHN_EXT_NBR,EMAIL_ADR,IPS_CYC_ID,IPS_RCVBL_TYPE_CD ' +
		',SRVC_CD,RLAT_KEY_ID,ID_TYPE_CD,ID_TYPE_DES,SCTY_GRP_DES,SENS_DATA_TYPE_DES ' +
		',SENS_DATA_CAT_CD,SENS_DATA_CAT_DES ' +
		'FROM OPENQUERY ' +
		'(L2PLink, ' +
		'''select CUST_CHARS_ID,SENS_DATA_TYPE_CD,EFF_BEGIN_TMST,EFF_END_TMST,SCTY_GRP_CD,CNTRC_CD ' +
		',MSTR_CHARS_ID,SENS_NME,TITLE_TXT,LINE_1_ADR,LINE_2_ADR,CTY_NME,STT_CD,PSTL_CD ' +
		',PROVINCE_CD,ISO_CTRY_CD,PHN_NBR,PHN_EXT_NBR,EMAIL_ADR,IPS_CYC_ID,IPS_RCVBL_TYPE_CD ' +
		',SRVC_CD,RLAT_KEY_ID,ID_TYPE_CD,ID_TYPE_DES,SCTY_GRP_DES,SENS_DATA_TYPE_DES ' +
		',SENS_DATA_CAT_CD,SENS_DATA_CAT_DES from sens_owner.v_sens_adr S ' +
		'WHERE ' +
		'S.SENS_DATA_TYPE_CD IN (''''PHYS'''',''''CONT'''',''''CONP'''') ' +
		'AND S.ID_TYPE_CD = ''''CIP_CUST_ID'''' AND S.RLAT_KEY_ID = ''''' + @CIS_ID + ''''' AND S.EFF_END_TMST > to_date(''''12/31/3333'''', ''''mm/dd/yyyy'''')'') '
		
		EXECUTE(@CMD2)
	exec('CALL SENS_CTX.CLEAR_CONTEXT_FGAC()') AT L2PLink
	
	IF EXISTS (SELECT * FROM #CUST_INFO_SENSITIVE_ALL WHERE RLAT_KEY_ID = @CIS_ID AND ID_TYPE_CD = 'CIP_CUST_ID')
		BEGIN
			SELECT DISTINCT
					(S.CUST_CHARS_ID) AS CUST_CHARS_ID, 
					PHYS.SENS_NME AS H5_H6_Customer_Name,
					CASE 
						WHEN	CHARINDEX(' ', RTRIM(LTRIM(CONT.SENS_NME))) = 0 THEN RTRIM(LTRIM(CONT.SENS_NME)) 
						ELSE	SUBSTRING(CONT.SENS_NME, CHARINDEX(' ', CONT.SENS_NME) + 1, LEN(CONT.SENS_NME)) 
						END  AS H5_H6_Contact_Last_Name, 
					CASE 
						WHEN	CHARINDEX(' ', RTRIM(LTRIM(CONT.SENS_NME))) = 0 THEN '' 
						ELSE	SUBSTRING(CONT.SENS_NME, 1, CHARINDEX(' ', CONT.SENS_NME) - 1) END AS H5_H6_Contact_First_Name,
					PHYS.LINE_1_ADR AS H5_H6_Address,
					PHYS.CTY_NME AS H5_H6_City, 
					PHYS.STT_CD AS H5_H6_State,
					PHYS.CTRY_CD AS H5_H6_Country,
					PHYS.PROVINCE_CD AS H5_H6_Prov_Muni,
					PHYS.PSTL_CD AS H5_H6_Zip_Code,
					PHYS.EMAIL_ADR AS H5_H6_EMAIL,
					PHYS.PHN_NBR AS H5_H6_CUSTOMER_PHONE,
					CASE 
						WHEN	CHARINDEX(' ', RTRIM(LTRIM(CONP.SENS_NME))) = 0 THEN RTRIM(LTRIM(CONP.SENS_NME)) 
						ELSE	SUBSTRING(CONP.SENS_NME, CHARINDEX(' ', CONP.SENS_NME) + 1, LEN(CONP.SENS_NME)) 
						END		AS On_Site_Contact_Last_Name, 
					CASE 
						WHEN	CHARINDEX(' ', RTRIM(LTRIM(CONP.SENS_NME))) = 0 THEN '' 
						ELSE	SUBSTRING(CONP.SENS_NME, 1, CHARINDEX(' ', CONP.SENS_NME) - 1) 
						END		AS On_Site_Contact_First_Name,
					CONP.EMAIL_ADR AS On_Site_Contact_Email,
					S.RLAT_KEY_ID	AS RLAT_KEY_ID,
					S.ID_TYPE_CD	AS ID_TYPE_CD,
					S.SCTY_GRP_CD	AS SCTY_GRP_CD
			FROM	#CUST_INFO_SENSITIVE_ALL S
					LEFT OUTER JOIN #CUST_INFO_SENSITIVE_ALL PHYS ON	
								S.ID_TYPE_CD			= PHYS.ID_TYPE_CD	AND
								PHYS.SENS_DATA_TYPE_CD	= 'PHYS'			AND 
								S.RLAT_KEY_ID			= PHYS.RLAT_KEY_ID	AND
								S.CUST_CHARS_ID			= PHYS.CUST_CHARS_ID
					LEFT OUTER JOIN #CUST_INFO_SENSITIVE_ALL CONT ON	
								S.ID_TYPE_CD			= CONT.ID_TYPE_CD	AND
								CONT.SENS_DATA_TYPE_CD	= 'CONT'			AND
								S.RLAT_KEY_ID			= CONT.RLAT_KEY_ID	AND
								S.CUST_CHARS_ID			= CONT.CUST_CHARS_ID
					LEFT OUTER JOIN #CUST_INFO_SENSITIVE_ALL CONP ON	
								S.ID_TYPE_CD			= CONP.ID_TYPE_CD	AND
								CONP.SENS_DATA_TYPE_CD	= 'CONP'			AND
								S.RLAT_KEY_ID			= CONP.RLAT_KEY_ID	AND
								S.CUST_CHARS_ID			= CONP.CUST_CHARS_ID
			WHERE	S.ID_TYPE_CD = 'CIP_CUST_ID' 
				AND S.EFF_END_TMST > GETDATE()
				AND (PHYS.SENS_NME is not null or CONT.SENS_NME is not null or CONP.SENS_NME is not null)
				AND	S.RLAT_KEY_ID = @CIS_ID
				AND	S.CUST_CHARS_ID = CASE @CHARS_ID
										WHEN 0	THEN	s.CUST_CHARS_ID
										ELSE @CHARS_ID
										END
										
										 		
					
		END
										
END TRY
		
BEGIN CATCH

END CATCH	
	
END
